#!/usr/bin/perl

# for CVS
# $Id: TANet-daily.pl,v 1.1 2005/03/28 07:48:11 jal Exp $

#
# 86400 was decreased because we are calculating yesterday's data.
#
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time-86400);
$mon++;
$year+=1900;

#
# 1. check in-interface and out-interface to make sure if we need this flow
# 2. classify the flow to specified network
#
#
#
#

##############################################################################
#
# Modify the following to meet your configuration.
#
# jal.050328: CyqέpC
#
# $dir is where you put your program and config files
# $rawdir is where the raw log files kept
# $outputdir is where the output files should be
#

$dir       = "/home/analyzer";
$rawdir    = "/home/tanet";
$flowprint = "/usr/local/bin/flow-print";
$outputdir = "/usr/local/www/data/netflow/TANet";
$htmldir   = sprintf ("%s/html/%04d%02d%02d", $outputdir, $year, $mon, $mday);
$textdir   = sprintf ("%s/text", $outputdir);
$rawoutput = sprintf ("%s/raw",  $outputdir);
$overlow   = "1000";
$TopN      = 100;
@output_network = ("200.201");

$protfile = "$dir/protocols";
$servfile = "$dir/services";
$intranet = "$dir/intranet";

##############################################################################
#
# Do not modify the following code!
#

require "$dir/TANet-netflow.pl";
&init_prot( $protfile );
&init_serv( $servfile );
&init_InNet( $intranet );

# modified by ericlin@cabin.idv.tw, 2003/07/13
# jal.031210: oOs flow-tools ϥΡAFreeBSD Цw /usr/ports/net/flow-tools/

$dir = sprintf ("%04d/%04d-%02d/%04d-%02d-%02d", $year, $year, $mon, $year, $mon, $mday);

opendir DIRREF, "$rawdir/$dir" || die $!;

@flowfiles = grep /^ft/, readdir DIRREF;

closedir DIRREF;

#for ($i=0; $i&lt;24; $i++) {
foreach (@flowfiles) {
 open FLOWDATA, "$flowprint -f0 < $rawdir/$dir/$_ |" || die $!;
   while (<FLOWDATA>) {
                  
   chomp;

#
# $sif, $dif: input/output interface  (get it from router by snmpwalk)
# $src, $dst: source/destination ip
# $proto    : protocol (refer to /etc/protocols, ICMP = 1, TCP = 6, UDP = 17)
# $sp,  $dp : source/destination port (transport layer protocol, /etc/services)
# $pkts     : total packets in this flow
# $size     : total octects in this flow
#

#
# The reason we use substr and index instead of split is due to the
# consideration of efficiency.
#
 ($sif, $src, $dif, $dst, $proto, $sp, $dp, $pkts, $size) = split /\s+/ , $_;


 $proto=hex($proto);
 $sp=hex($sp);
 $dp=hex($dp);

#
# the unit of $pkts is Kilo
# the unit of $size is Mega
#

   $pkts /= 1000;
   $size /= (1024*1024);

#
# Determine the IN/OUT traffic
#

   &chkInOutNetwork;
   
   } # while (<STDIN>)
}

#
# RAW File processing finished.
# Begin generating daily output diagrams.
#

mkdir $htmldir,0755;
mkdir $textdir,0755;

#
# Call subroutines to perform the output format.
#

&daily_summary;
&daily_summary_html;
&output_daily_topn_html;
&daily_classc_output;

##############################################################################
#
# subroutines begin here:
#

sub update_rec {
   my($net, $io) = @_;
   
   if ($proto == 6 || $proto == 17) {
      if ($service{"$sp"}) {
         $port = $sp;
      }
      elsif ($service{"$dp"}) {
         $port = $dp;
      }
      else {
         $port = "others";
      }
   }
   elsif ($proto == 1) {
      $port = "icmp";
   }
   
   #
   # Due to the unbearable data size,
   # we only maintain the IN-DST/OUT-SRC IP array.
   # Only Class-C array will be kept for IN-SRC/OUT-DST.
   #
   if ($io eq "IN") {
      my($a, $b, $c, $d) = split(/\./,"$src");
      $src = sprintf("%d.%d.%d", $a, $b, $c);
      ${$net.$io.SRC.$port.FLOWC}{"$src"} ++;
      ${$net.$io.SRC.$port.PKTSC}{"$src"} += $pkts;
      ${$net.$io.SRC.$port.SIZEC}{"$src"} += $size;
      ${$net.$io.DST.$port.FLOW}{"$dst"} ++;
      ${$net.$io.DST.$port.PKTS}{"$dst"} += $pkts;
      ${$net.$io.DST.$port.SIZE}{"$dst"} += $size;
   }
   else {
      my($a, $b, $c, $d) = split(/\./,"$dst");
      $dst = sprintf("%d.%d.%d", $a, $b, $c);
      ${$net.$io.SRC.$port.FLOW}{"$src"} ++;
      ${$net.$io.SRC.$port.PKTS}{"$src"} += $pkts;
      ${$net.$io.SRC.$port.SIZE}{"$src"} += $size;
      ${$net.$io.DST.$port.FLOWC}{"$dst"} ++;
      ${$net.$io.DST.$port.PKTSC}{"$dst"} += $pkts;
      ${$net.$io.DST.$port.SIZEC}{"$dst"} += $size;
   }
}

#
# Calculate the daily summary here!
# Such as the summation of each kind of traffic.
#
sub daily_summary {
   my($net) = "TANet";
   my($io, $sd, $port, $ip);
    foreach $io ("IN", "OUT") {
     foreach $sd ("SRC", "DST") {
      foreach $port (keys(%service)) {
       if ($service{$port} ne "total") {
        foreach $fps ("FLOW", "PKTS", "SIZE") {
         #
         # Only IN-DST & OUT-SRC traffic need to calculate the Class-C traffic
         #
         if (($io eq "IN" && $sd eq "DST") || ($io eq "OUT" && $sd eq "SRC")) {
          foreach $ip (keys(%{$net.$io.$sd.$port.$fps})) {
           my($a, $b, $c, $d) = split(/\./,"$ip");
           my($ipc) = sprintf("%d.%d.%d", $a, $b, $c);
           #
           # Total amount of per IP/ClassC
           #
           ${$net.$io.$sd.$port.$fps.C}{"$ipc"} += ${$net.$io.$sd.$port.$fps}{"$ip"};
           ${$net.$io.$sd.total.$fps.C}{"$ipc"} += ${$net.$io.$sd.$port.$fps}{"$ip"};
           ${$net.$io.$sd.total.$fps}{"$ip"} += ${$net.$io.$sd.$port.$fps}{"$ip"};
           #
           # Total amount of per $net.$io
           #
           ${$net.$io.SUM.$port.$fps} += ${$net.$io.$sd.$port.$fps}{"$ip"};
           ${$net.$io.SUM.total.$fps} += ${$net.$io.$sd.$port.$fps}{"$ip"};
          }
         }
         else {
          foreach $ip (keys(%{$net.$io.$sd.$port.$fps.C})) {
           ${$net.$io.$sd.total.$fps.C}{"$ip"} += ${$net.$io.$sd.$port.$fps.C}{"$ip"};
          }
         }
        } # fps
       } # if
      } # port
     } # sd
    } # io

#
# Debug output.
#
if (0) {

   if (0) {
   foreach $net ("HiNet", "SeedNet", "TANet") {
    foreach $io ("IN", "OUT") {
     foreach $sd ("SRC", "DST") {
      foreach $port (keys(%service)) {
         foreach $ip (keys(%{$net.$io.$sd.$port.FLOW})) {
            printf ("%8s %3s %3s %10s %18s %3d %8.3f %8.3f\n",
                   $net, $io, $sd, $service{$port}, $ip, 
                   ${$net.$io.$sd.$port.FLOW}{"$ip"},
                   ${$net.$io.$sd.$port.PKTS}{"$ip"},
                   ${$net.$io.$sd.$port.SIZE}{"$ip"});
         }
       }

     } # sd
    } # io
   } # net
   }

   foreach $net ("HiNet", "SeedNet", "TANet") {
    foreach $io ("IN", "OUT") {
     foreach $sd ("SRC", "DST") {
      foreach $port (keys(%service)) {
         foreach $ip (keys(%{$net.$io.$sd.total.FLOWC})) {
          if ( ${$net.$io.$sd.$port.FLOWC}{"$ip"} ) {
            printf ("%8s %3s %3s %10s %18s %3d %8.3f %8.3f\n",
                   $net, $io, $sd, $service{$port}, $ip, 
                   ${$net.$io.$sd.$port.FLOWC}{"$ip"},
                   ${$net.$io.$sd.$port.PKTSC}{"$ip"},
                   ${$net.$io.$sd.$port.SIZEC}{"$ip"});
          }
         }
      } # port

     } # sd
    } # io
   } # net

   foreach $net ("HiNet", "SeedNet", "TANet") {
    foreach $io ("IN", "OUT") {
     printf ("%8s %3s %3d %8.3f %8.3f\n",
              $net ,$io, 
              ${$net.$io.SUM.total.FLOW},
              ${$net.$io.SUM.total.PKTS},
              ${$net.$io.SUM.total.SIZE});
    }
   }
} # if ($DEBUG)

}

sub daily_summary_html {
   my($net) = "TANet";
   open FILE, ">$htmldir/summary.html" or die $!;
   printf FILE ("<html>\n<body bgcolor=\"#ffffff\">\n");
   printf FILE ("<title>%04d-%02d-%02d Statistics </title>\n", $year, $mon, $mday);
   print FILE "<center>\n";
   printf FILE ("%04d-%02d-%02d Traffic Statistics\n", $year, $mon, $mday);
   printf FILE ("<br>\n");
   print FILE "<table>\n";
   print FILE "<table border=2 width=80%>\n";
   print FILE "<tr bgcolor=lightskyblue><td align=right><font size=2 color=#666666>Direction<td align=right><font size=2 color=#666666>Flows<td align=right><font size=2 color=#666666>KPackets<td align=right><font size=2 color=#666666>MBytes</td></td></td></td></tr>\n";
   
      foreach $io ("IN", "OUT") {
         if ($io eq "IN") {
            $description = sprintf("%s ==> Internet", $net);
         }
         else {
            $description = sprintf("Internet ==> %s", $net);
         }
         printf FILE ("<tr><td align=right bgcolor=lightyellow>%s<td align=right><font size=2 color=#666666>%11d<td align=right><font size=2 color=#666666>%11.3f<td align=right><font size=2 color=#666666>%11.3f</tr>\n",
         $description,
         ${$net.$io.SUM.total.FLOW},
         ${$net.$io.SUM.total.PKTS},
         ${$net.$io.SUM.total.SIZE});
      }
   print FILE "</table>\n";

      foreach $io ("IN", "OUT") {
         if ($io eq "IN") {
            $description = sprintf("%s ==> Internet", $net);
         }
         else {
            $description = sprintf("Internet ==> %s", $net);
         }
         printf FILE ("<br>\n");
         foreach $port (keys(%service)) {
            if (${$net.$io.SUM.$port.SIZE}) {
               $SUM{$port} = ${$net.$io.SUM.$port.SIZE};
            }
         }
         my (@sorted) = ( sort { $SUM{$b} <=> $SUM{$a} } keys %SUM );
         print FILE "<table>\n";
         print FILE "<table border=2 width=80%>\n";
         print FILE "<caption>$description Traffic</caption>\n";
         print FILE "<tr bgcolor=lightskyblue><td align=right><font size=2 color=#666666>Application<td align=right><font size=2 color=#666666>Flows<td align=right><font size=2 color=#666666>%<td align=right><font size=2 color=#666666>KPackets<td align=right><font size=2 color=#666666>%<td align=right><font size=2 color=#666666>MBytes<td align=right><font size=2 color=#666666>%</td></tr>\n";
         for ($i=0; $i<20; $i++) {
            if (${$net.$io.SUM.$sorted[$i].SIZE}) {
               printf FILE ("<tr><td align=right bgcolor=lightyellow><font size=2 color=#666666>%s<td align=right><font size=2 color=#666666>%11d<td align=right><font size=2 color=#666666>%7.3f%%<td align=right><font size=2 color=#666666>%11.3f<td align=right><font size=2 color=#666666> %7.3f%%<td align=right><font size=2 color=#666666> %11.3f<td align=right><font size=2 color=#666666> %7.3f%%</tr>\n",
                   $service{$sorted[$i]},
                   ${$net.$io.SUM.$sorted[$i].FLOW},
                   (${$net.$io.SUM.$sorted[$i].FLOW}/${$net.$io.SUM.total.FLOW})*100,
                   ${$net.$io.SUM.$sorted[$i].PKTS},
                   (${$net.$io.SUM.$sorted[$i].PKTS}/${$net.$io.SUM.total.PKTS})*100,
                   ${$net.$io.SUM.$sorted[$i].SIZE},
                   (${$net.$io.SUM.$sorted[$i].SIZE}/${$net.$io.SUM.total.SIZE})*100);
            }
         }
         print FILE "</table>\n";
      }
   print FILE "</html>\n";
   close FILE;
#   system("/usr/bin/gzip $htmldir/summary.html");
}

#
# Output text summary of per Class C network traffic.
# This is useful for post processing/analysis.
#
sub daily_classc_output {
   my($i,$j);
   my($perc);
   my($io, $sd, $iosd, $description);
   my($net) = "TANet";
   foreach $io ("IN", "OUT") {
      if ($io eq "IN") {
         $iosd = "INDST";
         $description = "Incoming";
      }
      else {
         $iosd = "OUTSRC";
         $description = "Outgoing";
      }
      my($file) = sprintf ("%04d%02d%02d-%s", $year, $mon, $mday, $io);
      my($raw)  = sprintf ("%04d%02d%02d-%s", $year, $mon, $mday, $io);
      my($html) = sprintf ("classc-%s.html", $io);
      open FILE, ">$textdir/$file" or die $!;
      open RAW,  ">$rawoutput/$raw" or die $!;
      open HTML, ">$htmldir/$html" or die $!;
      print HTML "<html>\n<body bgcolor=\"#ffffff\">\n";
      printf HTML ("<title>%04d-%02d-%02d Statistics of CLASSC Traffic</title>\n", $year, $mon, $mday);
      print HTML "<center>\n";
      printf HTML ("%04d-%02d-%02d Statistics of <font color=red>CLASSC %s</font> Traffic\n", $year, $mon, $mday, $io);
      printf HTML ("<br>\n");
      print HTML "<table>\n";
      print HTML "<table border=2 width=80%>\n";

      printf FILE ("%5s Subnet  ALL(MB)   ALL%%   www%%   ftp%% telnt%%  mail%%   dns%%  news%% other%%\n", $io);
      printf RAW  ("%16s     ALL(MB)         www         ftp      telnet        mail         dns        news\n", $description);
      printf HTML ("<tr bgcolor=red><td bgcolor=lightgreen>%5s Subnet  <td>ALL(MB)   <td>ALL%%   <td>www%%   <td>ftp%% <td>telnet%%  <td>mail%%   <td>dns%%  <td>news%% <td>others%%</tr>\n", $io);
      #
      # Summary for Total In/Out
      # Used for raw output
      #
      print RAW "           TOTAL";
      foreach $port ("total", "80", "20", "23", "25", "53", "119") {
         printf RAW (" %11.5f", ${$net.$io.SUM.$port.SIZE});
      }
      print RAW "\n";
      foreach $ip (sort keys %{$net.$iosd.total.SIZE}) {
         foreach $port ("total", "80", "20", "23", "25", "53", "119", "others") {
            if (${$net.$iosd.total.SIZE}{$ip}) {
               if ($port eq "total") {
                  printf RAW ("%16s %11.5f ", $ip, ${$net.$iosd.$port.SIZE}{$ip});
               }
               elsif ($port ne "others") {
                  printf RAW ("%11.5f ", ${$net.$iosd.$port.SIZE}{$ip});
               }
            }
         }
         if (${$net.$iosd.total.SIZE}{$ip}) {
            print RAW "\n";
         }
      }
      #
      # Begin the per classc list
      #                                 
      foreach $ip (sort keys %{$net.$iosd.total.SIZEC}) {
         foreach $port ("total", "80", "20", "23", "25", "53", "119", "others") {
            ${$iosd.SUM}{$port}{$ip} = ${$net.$iosd.$port.SIZEC}{$ip};
            if (${$iosd.SUM}{total}{$ip}) {
               if ($port eq "total") {
                  $perc = (${$iosd.SUM}{total}{$ip}/${$net.$io.SUM.total.SIZE})*100;
                  printf FILE ("%12s %8.2f %6.2f ", $ip, ${$iosd.SUM}{total}{$ip}, $perc);
                  printf HTML ("<tr bgcolor=lightblue><td bgcolor=pink>%12s <td>%8.2f <td>%6.2f ", $ip, ${$iosd.SUM}{total}{$ip}, $perc);
               }
               else {
                  $perc = (${$iosd.SUM}{$port}{$ip}/${$iosd.SUM}{total}{$ip})*100;
                  printf FILE ("%6.2f ", $perc);
                  printf HTML ("<td>%6.2f ", $perc);
               }
            }
         }
         if (${$iosd.SUM}{total}{$ip}) {
            print FILE "\n";
            print HTML "</tr>\n";
         }
      }
   print HTML "</table>\n";
   close FILE;
   close RAW;
   close HTML;
#   system("/usr/bin/gzip $textdir/$file");
#   system("/usr/bin/gzip $rawoutput/$raw");
#   system("/usr/bin/gzip $htmldir/$html");
   }
}

sub daily_classc_fps_text_output {
   my($i,$j);
   my($file) = sprintf ("%04d%02d%02d", $year, $mon, $mday);
   open FILE, ">$textdir/$file" or die $!;
   print FILE "      Subnet   InFlow    InKPkts   InMBytes    OutFlow   OutKPkts   OutMBytes\n";
   foreach $i (@output_network) {
      for ($j=0; $j<255; $j++) {
         my($ip) = sprintf ("%s.%s", $i, $j);
         if (${TANetINDSTtotalFLOWC}{"$ip"} || ${SeedNetINDSTtotalFLOWC}{"$ip"} || ${HiNetINDSTtotalFLOWC}{"$ip"}) {
            printf FILE ("%12s %8d %10.2f %10.2f   %8d %10.2f  %10.2f\n",
               $ip,
               ${TANetINDSTtotalFLOWC}{"$ip"}+${SeedNetINDSTtotalFLOWC}{"$ip"}+${HiNetINDSTtotalFLOWC}{"$ip"},
               ${TANetINDSTtotalPKTSC}{"$ip"}+${SeedNetINDSTtotalPKTSC}{"$ip"}+${HiNetINDSTtotalPKTSC}{"$ip"},
               ${TANetINDSTtotalSIZEC}{"$ip"}+${SeedNetINDSTtotalSIZEC}{"$ip"}+${HiNetINDSTtotalSIZEC}{"$ip"},
               ${TANetOUTSRCtotalFLOWC}{"$ip"}+${SeedNetOUTSRCtotalFLOWC}{"$ip"}+${HiNetOUTSRCtotalFLOWC}{"$ip"},
               ${TANetOUTSRCtotalPKTSC}{"$ip"}+${SeedNetOUTSRCtotalPKTSC}{"$ip"}+${HiNetOUTSRCtotalPKTSC}{"$ip"},
               ${TANetOUTSRCtotalSIZEC}{"$ip"}+${SeedNetOUTSRCtotalSIZEC}{"$ip"}+${HiNetOUTSRCtotalSIZEC}{"$ip"});
         }
      }
   }
   close FILE;
   system("/usr/bin/gzip $textdir/$file");
}

sub output_daily_topn_html {
   my($io, $sd, $port);
   my($net) = "TANet";
      foreach $io ("IN", "OUT") {
         foreach $sd ("SRC", "DST") {
            foreach $port (keys(%service)) {
               if (${$net.$io.SUM.$port.FLOW}) {
                  &daily_classc_topn_output_html($net, $io, $sd, $port);
                  if (($io eq "IN" && $sd eq "DST") || ($io eq "OUT" && $sd eq "SRC")) {
                     &daily_ip_topn_output_html($net, $io, $sd, $port);
                  }
               }
            }
         }
      }
}

sub daily_ip_topn_output_html {
   my($net, $io, $sd, $port) = @_;
   my($description);
   if ($io eq "IN") {
      $description = sprintf("%s ==> Internet", $net);
   }
   else {
      $description = sprintf("Internet ==> %s", $net);
   }
   my($file) = sprintf ("%s/%s-%s-%s-%s-IP.html", $htmldir, $net, $service{$port}, $io, $sd);

   open FILE, ">$file" or die $!;
   printf FILE ("<html>\n<body bgcolor=\"#ffffff\">\n", $year, $mon, $mday, $port);
   printf FILE ("<title>%04d-%02d-%02d Statistics of %s Traffic</title>\n", $year, $mon, $mday, $service{$port});
   print FILE "<center>\n";

   printf FILE ("%04d-%02d-%02d Statistics of <font color=red>%s</font> Traffic\n", $year, $mon, $mday, $service{$port});

   printf FILE ("<br>\n");
   
   print FILE "<table>\n";
   print FILE "<table border=2 width=80%>\n";
   if ($sd eq "SRC") {
#      print FILE "<tr bgcolor=lightskyblue>ows<td align=right><font size=2 color=#666666>%<td align=right><font size=2 color=#666666>KPackets<td align=right><font size=2 color=#666666>%<td align=right><font size=2 color=#666666>MBytes<td align=right><font size=2 color=#666666>%</td></td></td></td></td></tr>\n";
      print FILE "<tr bgcolor=lightskyblue><td align=right><font size=2 color=#666666>Source</td><td align=right><font size=2 color=#666666>Flows</td><td align=right><font size=2 color=#666666>%</td><td align=right><font size=2 color=#666666>KPackets</td><td align=right><font size=2 color=#666666>%</td><td align=right><font size=2 color=#666666>MBytes</td><td align=right><font size=2 color=#666666>%</td></tr>\n";
   }
   else {
#      print FILE "<tr bgcolor=lightskyblue><td align=right><font size=2 color=#666666>Flows</td><td align=right><font size=2 color=#666666>%</td><td align=right><font size=2 color=#666666>KPackets</td><td align=right><font size=2 color=#666666>%</td><td align=right><font size=2 color=#666666>MBytes</td><td align=right><font size=2 color=#666666>%</td></tr>\n";
      print FILE "<tr bgcolor=lightskyblue><td align=right><font size=2 color=#666666>Destination</td><td align=right><font size=2 color=#666666>Flows</td><td align=right><font size=2 color=#666666>%</td><td align=right><font size=2 color=#666666>KPackets</td><td align=right><font size=2 color=#666666>%</td><td align=right><font size=2 color=#666666>MBytes</td><td align=right><font size=2 color=#666666>%</td></tr>\n";
   }   

# first, print the "type" to "total" ratio

   printf FILE ("<tr bgcolor=lightyellow><td align=right><font size=2 color=#666666>%s<td align=right><font size=2 color=#666666>%11d<td align=right><font size=2 color=#666666>%7.3f%%<td align=right><font size=2 color=#666666>%11.3f<td align=right><font size=2 color=#666666>%7.3f%%<td align=right><font size=2 color=#666666>%11.3f<td align=right><font size=2 color=#666666>%7.3f%%</tr>\n",
                $description,
                ${$net.$io.SUM.$port.FLOW},
                (${$net.$io.SUM.$port.FLOW}/${$net.$io.SUM.total.FLOW})*100,
                ${$net.$io.SUM.$port.PKTS},
                (${$net.$io.SUM.$port.PKTS}/${$net.$io.SUM.total.PKTS})*100,
                ${$net.$io.SUM.$port.SIZE},
                (${$net.$io.SUM.$port.SIZE}/${$net.$io.SUM.total.SIZE})*100);

# then print the TopN entries

   my(@sorted) = (sort { ${$net.$io.$sd.$port.SIZE}{$b} <=> ${$net.$io.$sd.$port.SIZE}{$a} } keys %{$net.$io.$sd.$port.SIZE});
   for ($i=0; $i<$TopN; $i++) {
# jal.040223: Ϭd DNS
     $fqdn = " ";

     if($sorted[$i]) { $fqdn = NSLookUp($sorted[$i]); }
     $size = ${$net.$io.$sd.$port.SIZE}{"$sorted[$i]"};

# jal.041117: Cyqw
     if ( $size >= 2000 )
     {
       $over = "bgcolor=pink";
       $size = sprintf("%.3fG", ($size/1000));
     }
     elsif( $size > 1000 && $size < 2000 )
     {
       $over = "bgcolor=FFFF00";
       $size = sprintf("%.3fG", ($size/1000));
     }
     else
     {
       $over = "";
       $size = sprintf("%dM", $size);
     }

#      if ( ${$net.$io.$sd.$port.SIZE}{"$sorted[$i]"} != 0 ) {
         printf FILE ("<tr %s><td align=right><font size=2 color=#666666>%15s(%s)</td><td align=right><font size=2 color=#666666>%11d</td><td align=right><font size=2 color=#666666>%7.3f%%</td><td align=right><font size=2 color=#666666>%11.3f</td><td align=right><font size=2 color=#666666>%7.3f%%</td><td align=right><font size=2 color=#666666>%11.3f</td><td align=right><font size=2 color=#666666>%7.3f%%</td></tr>\n",
            $over,$sorted[$i],$fqdn,
            ${$net.$io.$sd.$port.FLOW}{"$sorted[$i]"},
            (${$net.$io.$sd.$port.FLOW}{"$sorted[$i]"}/${$net.$io.SUM.$port.FLOW})*100,
            ${$net.$io.$sd.$port.PKTS}{"$sorted[$i]"},
            (${$net.$io.$sd.$port.PKTS}{"$sorted[$i]"}/${$net.$io.SUM.$port.PKTS})*100,
            ${$net.$io.$sd.$port.SIZE}{"$sorted[$i]"},
            (${$net.$io.$sd.$port.SIZE}{"$sorted[$i]"}/${$net.$io.SUM.$port.SIZE})*100);
#      }
   }
   print FILE "</table>\n";
   print FILE "<! modify by jal>\n"
   close FILE;
#   system("/usr/bin/gzip $file");

}

sub daily_classc_topn_output_html {
   my($net, $io, $sd, $port) = @_;
   my($description);
   if ($io eq "IN") {
      $description = sprintf("%s ==> Internet", $net);
   }
   else {
      $description = sprintf("Internet ==> %s", $net);
   }
   my($file) = sprintf ("%s/%s-%s-%s-%s-CLASSC.html", $htmldir, $net, $service{$port}, $io, $sd);
   open FILE, ">$file" or die $!;
   printf FILE ("<html>\n<body bgcolor=\"#ffffff\">\n", $year, $mon, $mday, $port);
   printf FILE ("<title>%04d-%02d-%02d Statistics of %s Traffic</title>\n", $year, $mon, $mday, $service{$port});
   print FILE "<center>\n";

   printf FILE ("%04d-%02d-%02d Statistics of <font color=red>%s</font> Traffic\n", $year, $mon, $mday, $service{$port});

   printf FILE ("<br>\n");
   
   print FILE "<table>\n";
   print FILE "<table border=2 width=80%>\n";
   if ($sd eq "SRC") {
#      print FILE "<tr bgcolor=lightskyblue>ows<td align=right><font size=2 color=#666666>%<td align=right><font size=2 color=#666666>KPackets<td align=right><font size=2 color=#666666>%<td align=right><font size=2 color=#666666>MBytes<td align=right><font size=2 color=#666666>%</td></td></td></td></td></tr>\n";
      print FILE "<tr bgcolor=lightskyblue><td align=right><font size=2 color=#666666>Source</td><td align=right><font size=2 color=#666666>Flows</td><td align=right><font size=2 color=#666666>%</td><td align=right><font size=2 color=#666666>KPackets</td><td align=right><font size=2 color=#666666>%</td><td align=right><font size=2 color=#666666>MBytes</td><td align=right><font size=2 color=#666666>%</td></tr>\n";
   }
   else {
#      print FILE "<tr bgcolor=lightskyblue><td align=right><font size=2 color=#666666>Flows<td align=right><font size=2 color=#666666>%<td align=right><font size=2 color=#666666>KPackets<td align=right><font size=2 color=#666666>%<td align=right><font size=2 color=#666666>MBytes<td align=right><font size=2 color=#666666>%</td></td></td></td></td></tr>\n";
      print FILE "<tr bgcolor=violetred><td align=right><font size=2 color=#666666>Destination</td><td align=right><font size=2 color=#666666>Flows</td><td align=right><font size=2 color=#666666>%</td><td align=right><font size=2 color=#666666>KPackets</td><td align=right><font size=2 color=#666666>%</td><td align=right><font size=2 color=#666666>MBytes</td><td align=right><font size=2 color=#666666>%</td></tr>\n";
   }   

# first, print the "type" to "total" ratio

   printf FILE ("<tr bgcolor=lightyellow><td align=right><font size=2 color=#666666>%s<td align=right><font size=2 color=#666666>%11d<td align=right><font size=2 color=#666666>%7.3f%%<td align=right><font size=2 color=#666666> %11.3f<td align=right><font size=2 color=#666666>%7.3f%%<td align=right><font size=2 color=#666666> %11.3f<td align=right><font size=2 color=#666666>%7.3f%%</tr>\n",
                $description,
                ${$net.$io.SUM.$port.FLOW},
                (${$net.$io.SUM.$port.FLOW}/${$net.$io.SUM.total.FLOW})*100,
                ${$net.$io.SUM.$port.PKTS},
                (${$net.$io.SUM.$port.PKTS}/${$net.$io.SUM.total.PKTS})*100,
                ${$net.$io.SUM.$port.SIZE},
                (${$net.$io.SUM.$port.SIZE}/${$net.$io.SUM.total.SIZE})*100);

# then print the TopN entries

   my(@sorted) = (sort { ${$net.$io.$sd.$port.SIZEC}{$b} <=> ${$net.$io.$sd.$port.SIZEC}{$a} } keys %{$net.$io.$sd.$port.SIZEC});
   for ($i=0; $i<$TopN; $i++) {
#      if ( ${$net.$io.$sd.$port.SIZE}{"$sorted[$i]"} != 0 ) {
         printf FILE ("<tr><td align=right><font size=2 color=#666666>%15s<td align=right><font size=2 color=#666666>%11d<td align=right><font size=2 color=#666666>%7.3f%%<td align=right><font size=2 color=#666666>%11.3f<td align=right><font size=2 color=#666666>%7.3f%%<td align=right><font size=2 color=#666666>%11.3f<td align=right><font size=2 color=#666666>%7.3f%%</tr>\n",
            $sorted[$i],
            ${$net.$io.$sd.$port.FLOWC}{"$sorted[$i]"},
            (${$net.$io.$sd.$port.FLOWC}{"$sorted[$i]"}/${$net.$io.SUM.$port.FLOW})*100,
            ${$net.$io.$sd.$port.PKTSC}{"$sorted[$i]"},
            (${$net.$io.$sd.$port.PKTSC}{"$sorted[$i]"}/${$net.$io.SUM.$port.PKTS})*100,
            ${$net.$io.$sd.$port.SIZEC}{"$sorted[$i]"},
            (${$net.$io.$sd.$port.SIZEC}{"$sorted[$i]"}/${$net.$io.SUM.$port.SIZE})*100);
#      }
   }
   print FILE "</table>\n";
   print FILE "<!modify by jal>\n"
   close FILE;
#   system("/usr/bin/gzip $file");
}
